// AnimateDoc.cpp : implementation of the CAnimateDoc class
//

#include "stdafx.h"
#include "Animate.h"

#include "AnimateDoc.h"
#include "AnimateView.h"
#include "MainFrm.h"

#include "crystal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnimateDoc

IMPLEMENT_DYNCREATE(CAnimateDoc, CDocument)

BEGIN_MESSAGE_MAP(CAnimateDoc, CDocument)
	//{{AFX_MSG_MAP(CAnimateDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnimateDoc construction/destruction

CAnimateDoc::CAnimateDoc()
{
	// TODO: add one-time construction code here
	INIT_FLAG = true;
}

CAnimateDoc::~CAnimateDoc()
{
}

BOOL CAnimateDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	if( !INIT_FLAG ) {
	
		CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
		cav->NewDocument();

	} else {

		INIT_FLAG = false;

	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAnimateDoc serialization

void CAnimateDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	
		CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
		int numFrames = cav->NUM_FRAMES;

		CString temp;
		temp.Format( "%d\n", numFrames );

		ar.WriteString( temp );

		temp.Format( "%d\n", cav->FRAMERATE );

		ar.WriteString( temp );

		float * rotAr;
		float * transAr;

		for( int i= 1; i <= numFrames; i++ ) {

			rotAr = cav->GetRotationArrayFor( i );
			transAr = cav->GetTranslationArrayFor( i );
			temp.Format( "%f\n", rotAr[0] );
			ar.WriteString( temp );
			temp.Format( "%f\n", rotAr[1] );
			ar.WriteString( temp );
			temp.Format( "%f\n", rotAr[2] );
			ar.WriteString( temp );
			temp.Format( "%f\n", rotAr[3] );
			ar.WriteString( temp );
			temp.Format( "%f\n", transAr[0] );
			ar.WriteString( temp );
			temp.Format( "%f\n", transAr[1] );
			ar.WriteString( temp );
			temp.Format( "%f\n", transAr[2] );
			ar.WriteString( temp );
			
		}


	}
	else
	{

		CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
		
		CString temp;
		ar.ReadString(temp);
		int numFrames = atoi( temp );
		ar.ReadString(temp);
		int framerate = atoi( temp );
		changeNumFrames( cav->NUM_FRAMES, numFrames - cav->NUM_FRAMES );
		
		cav->NUM_FRAMES = numFrames;
		cav->FRAMERATE = framerate;

		float deg;
		float x_ax;
		float y_ax;
		float z_ax;
		float x;
		float y;
		float z;

		for( int i = 1; i <= numFrames; i++ ) {
	
			ar.ReadString(temp);
			deg = (float) atof( temp );
			ar.ReadString(temp);
			x_ax = (float) atof( temp );
			ar.ReadString(temp);
			y_ax = (float) atof( temp );
			ar.ReadString(temp);
			z_ax = (float) atof( temp );
			ar.ReadString(temp);
			x = (float) atof( temp );
			ar.ReadString(temp);
			y = (float) atof( temp );
			ar.ReadString(temp);
			z = (float) atof( temp );

			cav->SetRotationFor( i, deg, x_ax, y_ax, z_ax );
			cav->SetTranslationFor( i, x, y, z );

			cav->CalculateFrame( i );

		}

		cav->OnGoToFrame( 1 );
		CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
		cm->OnGoToFrame( 1 );

	}
}

/////////////////////////////////////////////////////////////////////////////
// CAnimateDoc diagnostics

#ifdef _DEBUG
void CAnimateDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAnimateDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAnimateDoc commands
