// AnimateView.cpp : implementation of the CAnimateView class
//

#include "stdafx.h"
#include "Animate.h"

#include "AnimateDoc.h"
#include "AnimateView.h"
#include "MainFrm.h"

#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>
#include "f:\cs184\glut-3.7\glut.h"

#include "crystal.h"
#include "GoToFrameDialog.h"
#include "frameCommitDialog.h"
#include "InterpolateDialog.h"

#include "FDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnimateView

IMPLEMENT_DYNCREATE(CAnimateView, CView)

BEGIN_MESSAGE_MAP(CAnimateView, CView)
	//{{AFX_MSG_MAP(CAnimateView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_GO_TO_FRAME, OnGoToFrame)
	ON_COMMAND(ID_COMMIT_FRAME, OnCommitFrame)
	ON_COMMAND(ID_FIRST_FRAME, OnFirstFrame)
	ON_WM_MOUSEWHEEL()
	ON_COMMAND(ID_INTERPOLATE, OnInterpolate)
	ON_COMMAND(ID_PLAY_ANIMATION, OnPlayAnimation)
	ON_COMMAND(ID_STOP_ANIMATION, OnStopAnimation)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnimateView construction/destruction

CAnimateView::CAnimateView()
{
	// TODO: add construction code here

	currFrame = 1;
	IN_ANIMATION = 1;
	NO_ANIMATION = 0;
	animation = NO_ANIMATION;
	FRAMERATE = 20;
	NUM_FRAMES = 30;	
	
}

CAnimateView::~CAnimateView()
{
}

BOOL CAnimateView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	// set window style
	//  
	cs.style |= WS_CLIPCHILDREN | WS_CLIPSIBLINGS ;


	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAnimateView drawing

void CAnimateView::OnDraw(CDC* pDC)
{
	CAnimateDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	DrawNextFrame();

}

/////////////////////////////////////////////////////////////////////////////
// CAnimateView printing

BOOL CAnimateView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CAnimateView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CAnimateView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CAnimateView diagnostics

#ifdef _DEBUG
void CAnimateView::AssertValid() const
{
	CView::AssertValid();
}

void CAnimateView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CAnimateDoc* CAnimateView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAnimateDoc)));
	return (CAnimateDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAnimateView message handlers


int CAnimateView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	
	CenterWindow();
	SetWindowPos( &wndTopMost, 0, 0, 1000, 1000, 0 );

	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	//Create an appropriate Rendering Context which is needed by OGL
//to draw anything.

	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		24,		//color depth
		0,0,0,0,0,0,
		0,0,0,0,0,0,0,
		32,	//number of Depth buffer bits per pixel
		0,0,
		PFD_MAIN_PLANE,
		0,
		0,0,0
	};

	CClientDC clientDC(this);

	int pixelformat=ChoosePixelFormat(clientDC.m_hDC,&pfd);
	SetPixelFormat(clientDC.m_hDC,pixelformat,&pfd);

	// Cross-check the pixel format 
	//Here, I'm checking only whether palette is needed
		
	DescribePixelFormat(clientDC.m_hDC,pixelformat,sizeof(pfd),&pfd);
	if(pfd.dwFlags & PFD_NEED_PALETTE) SetupLogicalPalette();


	// Create RC
	m_hRC= wglCreateContext(clientDC.m_hDC);

	//Set the state variables	

	wglMakeCurrent(clientDC.m_hDC,m_hRC);     //Make RC current

	glClearColor(0.0f,0.0f,0.0f,0.0f); //The color used to 
					//clear the screen is black

    glFrontFace(GL_CCW);	
	   //Vertices of the primitives are wound 
	   //in counter clock direction

	wglMakeCurrent(clientDC.m_hDC,NULL);    
	   //Make the RC not-current

	   //Initialize Timer for animation
	SetTimer(1,1,0);

    glutCreateWindow("Animation Cube");

	initDraw( NUM_FRAMES );


	return 0;
}

void CAnimateView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	
	KillTimer(1);
		wglDeleteContext(m_hRC);


}

void CAnimateView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	

	// TODO: Add your message handler code here
	

	CView::OnSize(nType, cx, cy);
	
	//GLdouble ar;
		// aspect ratio
	

	// ReInitialize Projection and 
	// ModelView Matrices to adapt to
	// new window size.
	
	CClientDC cdc(this);
	wglMakeCurrent(cdc.m_hDC,m_hRC);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); 
	//initialize the PROJECTION matrix

	//if(cy!=0)ar=(GLdouble)cx / (GLdouble)cy;
		
	//gluPerspective( 0, ar, -1, 100 );

	glOrtho(0,1,0,1,0,100);
		
    resize( cx, cy );        

	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity(); 
	//initialize the MODELVIEW matrix
	wglMakeCurrent(NULL,NULL);
}

BOOL CAnimateView::OnEraseBkgnd(CDC* pDC) 
{
	// Do not erase the background, just return
		
	//return CView::OnEraseBkgnd(pDC);
	return TRUE;

}

void CAnimateView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	if( animation == IN_ANIMATION ) {

		loadFrame( currFrame-1 );
		DrawNextFrame();

		if( currFrame == NUM_FRAMES ) {
			animation = NO_ANIMATION;
			SetTimer(1,1,0);			
		} else {
			currFrame++;
			CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
			cm->OnGoToFrame( currFrame );
		}

	} else {
	
	// Redraw the Frame	
	 DrawNextFrame();
	
	}

	CView::OnTimer(nIDEvent);


}

void CAnimateView::SetupLogicalPalette()
{
	struct
	{
		WORD VersionNumber;
		WORD NumberOfEntries;
		PALETTEENTRY PalEntryArr[256];
	} MyPalette = { 0x300, 256};

// Code for setting RGB values in 
// each of the 256 PALETTEENTRY structure of 
// MyPalette goes here. I have not included 
// it for it is too lengthy and doesn't 
// convey much. But If you get the following 
// message box, you will have to add it here. 

	AfxMessageBox(" Add colors to the Logical palette");
	
  
}


void CAnimateView::DrawNextFrame()
{

	CClientDC cdc(this);
	wglMakeCurrent(cdc.m_hDC,m_hRC);   
	  //Make the RC current

	glutInitDisplayMode(GLUT_RGB);

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			//Clear the Color and the Depth buffers
 	glMatrixMode(GL_MODELVIEW);
		
	glLoadIdentity();      //Initialize matrix

	// draw the cube
	display();

	glFlush();			// Make sure all the commands 
					//are executed
	SwapBuffers(cdc.m_hDC);		//Swap the buffers
	wglMakeCurrent(NULL,NULL);	//Make the RC not-current

}

void CAnimateView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	mouseMove( point.x, point.y );

	CView::OnMouseMove(nFlags, point);
}

void CAnimateView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	mouse( 0, 0, point.x, point.y );

	CView::OnLButtonDown(nFlags, point);
}

void CAnimateView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	mouse( 0, 1, point.x, point.y );

	CView::OnLButtonUp(nFlags, point);
}

void CAnimateView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	mouse( 2, 0, point.x, point.y );

	CView::OnRButtonDown(nFlags, point);
}

void CAnimateView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	

	mouse( 2, 1, point.x, point.y );

	CView::OnRButtonUp(nFlags, point);
}

BOOL CAnimateView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO: Add your message handler code here and/or call default
	
	mouseScroll( zDelta );

	return CView::OnMouseWheel(nFlags, zDelta, pt);
}

void CAnimateView::OnGoToFrame() 
{

	GoToFrameDialog gtf;

	int num = currFrame;
	
	int least = 1;
	int most = NUM_FRAMES;

	gtf.m_frame_edit_value.Format( "%d", num );

	BOOL done = false;

	while( !done ) {

		if( gtf.DoModal() == IDOK ) {
			CString numS = gtf.m_frame_edit_value;
			num = atoi( numS );
			if( num < least || num > most ) {
				CString msg;
				msg.Format( "Invalid frame: value must be between %d and %d", least, most );
				AfxMessageBox( msg );
			} else {
				OnGoToFrame( num );
				CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
				cm->OnGoToFrame( num );
				done = true;
			}
		} else {
			done = true;
		}
	}

	// TODO: Add your command handler code here
	
}

void CAnimateView::OnGoToFrame( int num ) {

	loadFrame( num-1 );
	currFrame = num;
	display();

}

void CAnimateView::OnCommitFrame() 
{
	// TODO: Add your command handler code here
	
	frameCommitDialog fc;

	int num = currFrame;

	int least = 1;
	int most = NUM_FRAMES;

	fc.m_frame_edit_value.Format( "%d", num );

	BOOL done = false;

	while( !done ) {

		if( fc.DoModal() == IDOK ) {
			CString numS = fc.m_frame_edit_value;
			num = atoi( numS );
			if( num < least || num > most ) {
				CString msg;
				msg.Format( "Invalid frame: value must be between %d and %d", least, most );
				AfxMessageBox( msg );
			} else {
				OnCommitFrame( num );
				CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
				cm->OnGoToFrame( num );
				done = true;
			}
		} else {
			done = true;
		}
	}

}

void CAnimateView::OnCommitFrame( int num ) {

	storeFrame( num-1 );
	currFrame = num;
}

void CAnimateView::OnInterpolate() 
{
	// TODO: Add your command handler code here
	
	InterpolateDialog i;

	int from = currFrame;
	int to = currFrame;

	int least = 1;
	int most = NUM_FRAMES;

	i.m_from_frame_edit_value.Format( "%d", from );
	i.m_to_frame_edit_value.Format( "%d", to );

	BOOL done = false;

	while( !done ) {

		if( i.DoModal() == IDOK ) {
			from = atoi( i.m_from_frame_edit_value );
			to = atoi( i.m_to_frame_edit_value );
			if( from < least || from > most ) {
				CString msg;
				msg.Format( "Invalid \"From\" frame: value must be between %d and %d", least, most );
				AfxMessageBox( msg );
			} else if( to < least || to > most ) {
				CString msg;
				msg.Format( "Invalid \"To\" frame: value must be between %d and %d", least, most );
				AfxMessageBox( msg );
			} else if( to < from ) {
				CString msg;
				msg.Format( "Invalid interpolation: the \"To\" frame must come after the \"From\" frame" );
				AfxMessageBox( msg );
			} else {
				interpolate( from-1, to-1 );
				currFrame = to;
				CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
				cm->OnGoToFrame( to );
				loadFrame(to-1);
				DrawNextFrame();
				done = true;
			}
		} else {
			done = true;
		}
	}

}

void CAnimateView::OnPlayAnimation() 
{
	// TODO: Add your command handler code here
	//currFrame = 1;
	CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
	cm->OnGoToFrame( currFrame );
	animation = IN_ANIMATION;
	SetTimer(1,1000/FRAMERATE,0);
	
}

void CAnimateView::OnStopAnimation() 
{
	// TODO: Add your command handler code here
	
	animation = NO_ANIMATION;
	SetTimer(1,1,0);

}

void CAnimateView::OnFirstFrame() 
{
	// TODO: Add your command handler code here
	OnGoToFrame( 1 );
}

CString CAnimateView::GetRotationFor( int frame ) 
{
	// TODO: Add your command handler code here
	return rotAt( frame - 1 );
}

CString CAnimateView::GetTranslationFor( int frame) 
{
	// TODO: Add your command handler code here
	return transAt( frame - 1 );
}

float * CAnimateView::GetRotationArrayFor( int frame ) 
{
	// TODO: Add your command handler code here
	return rotArrayAt( frame - 1 );
}

float * CAnimateView::GetTranslationArrayFor( int frame ) 
{
	// TODO: Add your command handler code here
	return transArrayAt( frame - 1 );
}

void CAnimateView::SetRotationFor( int frame, float deg, float x_ax, float y_ax, float z_ax ) {

	setRotAt( frame - 1, deg, x_ax, y_ax, z_ax );

}

void CAnimateView::SetTranslationFor( int frame, float x, float y, float z ) {

	setTransAt( frame - 1, x, y, z );

}

void CAnimateView::CalculateFrame( int frame ) {

	calculateFrame( frame - 1 );

}

void CAnimateView::NewDocument() {

	int defaultFrames = 30;
	int defaultFramerate = 20;

	changeNumFrames( NUM_FRAMES, defaultFrames - NUM_FRAMES );
	NUM_FRAMES = defaultFrames;
	FRAMERATE = defaultFramerate;
	
	for( int i = 0; i < defaultFrames; i++ ) {

		frontAndCenter();
		storeFrame( i );

	}

	OnGoToFrame( 1 );
	CMainFrame * cm = (CMainFrame*)(AfxGetApp()->m_pMainWnd);
	cm->OnGoToFrame( 1 );

}
