// AnimateView.h : interface of the CAnimateView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANIMATEVIEW_H__4C4FAB86_320F_4DAD_AFBE_9CCE1DC010C4__INCLUDED_)
#define AFX_ANIMATEVIEW_H__4C4FAB86_320F_4DAD_AFBE_9CCE1DC010C4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AnimateDoc.h"

class CAnimateView : public CView
{
protected: // create from serialization only
	CAnimateView();
	DECLARE_DYNCREATE(CAnimateView)

// Attributes
public:
	CAnimateDoc* GetDocument();
	int NUM_FRAMES;
	int FRAMERATE;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAnimateView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL
	void DrawNextFrame();
	void SetupLogicalPalette();
	HGLRC m_hRC;

// Implementation
public:
	virtual ~CAnimateView();
	void OnGoToFrame( int num );
	void OnCommitFrame( int num );
	CString GetRotationFor( int frame );
	float * GetRotationArrayFor( int frame );
	CString GetTranslationFor( int frame );
	float * GetTranslationArrayFor( int frame );
	void SetRotationFor( int frame, float deg, float x_ax, float y_ax, float z_ax );
	void SetTranslationFor( int frame, float x, float y, float z );
	void CalculateFrame( int frame );
	void NewDocument();
	afx_msg void OnPlayAnimation();
	afx_msg void OnStopAnimation();
	afx_msg void OnInterpolate();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnCommitFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	int currFrame;
	int IN_ANIMATION;
	int NO_ANIMATION;
	int animation;
	//{{AFX_MSG(CAnimateView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnGoToFrame();
	afx_msg void OnFirstFrame();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in AnimateView.cpp
inline CAnimateDoc* CAnimateView::GetDocument()
   { return (CAnimateDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ANIMATEVIEW_H__4C4FAB86_320F_4DAD_AFBE_9CCE1DC010C4__INCLUDED_)
