// FDialog.cpp : implementation file
//

#include "stdafx.h"
#include "Animate.h"
#include "FDialog.h"
#include "DialogBarEx.h"
#include "AnimateView.h"
#include "FramesSetupDialog.h"
#include "crystal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFDialog dialog


CFDialog::CFDialog(CWnd* pParent /*=NULL*/)
	: CDialogBarEx( )
{
	//{{AFX_DATA_INIT(CFDialog)
	m_frame_edit_value = _T("");
	m_rib_file_edit_value = _T("");
	//}}AFX_DATA_INIT
}


void CFDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialogBarEx::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDialog)
	DDX_Control(pDX, IDC_RIB_FILE, m_rib_file_edit);
	DDX_Control(pDX, IDC_ARROW_RIGHT_ROTATE, m_arrow_right_rotate);
	DDX_Control(pDX, IDC_ARROW_LEFT_ROTATE, m_arrow_left_rotate);
	DDX_Control(pDX, IDC_ARROW_BACKWARD, m_arrow_backward);
	DDX_Control(pDX, IDC_ARROW_FORWARD, m_arrow_forward);
	DDX_Control(pDX, IDC_ARROW_RIGHT, m_arrow_right);
	DDX_Control(pDX, IDC_ARROW_DOWN, m_arrow_down);
	DDX_Control(pDX, IDC_ARROW_LEFT, m_arrow_left);
	DDX_Control(pDX, IDC_ARROW_UP, m_arrow_up);
	DDX_Control(pDX, IDC_FDIALOG_FRAME_SLIDER, m_frame_slider);
	DDX_Control(pDX, IDC_GO_TO_FRAME, m_go_to_frame);
	DDX_Control(pDX, IDC_FDIALOG_FRAME_SPIN, m_frame_spin);
	DDX_Control(pDX, IDC_FDIALOG_FRAME_EDIT, m_frame_edit);
	DDX_Text(pDX, IDC_FDIALOG_FRAME_EDIT, m_frame_edit_value);
	DDX_Text(pDX, IDC_RIB_FILE, m_rib_file_edit_value);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFDialog, CDialogBarEx)
	//{{AFX_MSG_MAP(CFDialog)
	ON_BN_CLICKED(IDC_GO_TO_FRAME, OnGoToFrame)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_COMMIT_FRAME, OnCommitFrame)
	ON_BN_CLICKED(IDC_PLAY_ANIMATION, OnPlayAnimation)
	ON_BN_CLICKED(IDC_STOP_ANIMATION, OnStopAnimation)
	ON_BN_CLICKED(IDC_INTERPOLATE, OnInterpolate)
	ON_BN_CLICKED(IDC_ARROW_UP, OnArrowUp)
	ON_BN_CLICKED(IDC_ARROW_LEFT, OnArrowLeft)
	ON_BN_CLICKED(IDC_ARROW_DOWN, OnArrowDown)
	ON_BN_CLICKED(IDC_ARROW_RIGHT, OnArrowRight)
	ON_BN_CLICKED(IDC_ARROW_FORWARD, OnArrowForward)
	ON_BN_CLICKED(IDC_ARROW_BACKWARD, OnArrowBackward)
	ON_BN_CLICKED(IDC_FRONT_AND_CENTER, OnFrontAndCenter)
	ON_BN_CLICKED(IDC_FIRST_FRAME, OnFirstFrame)
	ON_BN_CLICKED(IDC_ARROW_LEFT_ROTATE, OnArrowLeftRotate)
	ON_BN_CLICKED(IDC_ARROW_RIGHT_ROTATE, OnArrowRightRotate)
	ON_COMMAND(ID_FRAMES_ANIMATIONPROPERTIES, OnFramesAnimationproperties)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CFDialog::OnInitDialogBar()
{
// TODO
// Add your custom initialization code here.


	HICON uparrow = AfxGetApp()->LoadIcon( IDI_ARROW_UP );
	m_arrow_up.SetIcon( uparrow );

	HICON leftarrow = AfxGetApp()->LoadIcon( IDI_ARROW_LEFT );
	m_arrow_left.SetIcon( leftarrow );

	HICON downarrow = AfxGetApp()->LoadIcon( IDI_ARROW_DOWN );
	m_arrow_down.SetIcon( downarrow );

	HICON rightarrow = AfxGetApp()->LoadIcon( IDI_ARROW_RIGHT );
	m_arrow_right.SetIcon( rightarrow );

	HICON forwardarrow = AfxGetApp()->LoadIcon( IDI_ARROW_FORWARD );
	m_arrow_forward.SetIcon( forwardarrow );

	HICON backwardarrow = AfxGetApp()->LoadIcon( IDI_ARROW_BACKWARD );
	m_arrow_backward.SetIcon( backwardarrow );

	HICON leftrotatearrow = AfxGetApp()->LoadIcon( IDI_ARROW_LEFT_ROTATE );
	m_arrow_left_rotate.SetIcon( leftrotatearrow );
	
	HICON rightrotatearrow = AfxGetApp()->LoadIcon( IDI_ARROW_RIGHT_ROTATE );
	m_arrow_right_rotate.SetIcon( rightrotatearrow );

	CDialogBarEx::OnInitDialogBar();

	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	int numFrames = cav->NUM_FRAMES;

	m_frame_spin.SetRange( 1, numFrames );
	m_frame_slider.SetRange( 1, numFrames );

	currPoint = CPoint( 0, 0 );
	changePoint = .5;
	changeRotate = 80;
}


/////////////////////////////////////////////////////////////////////////////
// CFDialog message handlers

void CFDialog::OnGoToFrame() 
{
	// TODO: Add your control notification handler code here
	CString nums;
	m_frame_edit.GetWindowText( nums );

	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	int numFrames = cav->NUM_FRAMES;

	int least = 1;
	int most = numFrames;
	int num = atoi( nums );
	if( num < least || num > most ) {
		CString msg;
		msg.Format( "Invalid frame: value must be between %d and %d", least, most );
		AfxMessageBox( msg );
	} else {
		m_frame_slider.SetPos( num );
		CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
		cav->OnGoToFrame( num );
	}

}


void CFDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	
	int num = m_frame_slider.GetPos();
	CString nums;
	nums.Format( "%d", num );
	m_frame_edit.SetWindowText( nums );

	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnGoToFrame( num );
	CDialogBarEx::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CFDialog::OnCommitFrame() 
{
	// TODO: Add your control notification handler code here

	CString nums;
	m_frame_edit.GetWindowText( nums );

	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnCommitFrame();
	/*int numFrames = cav->NUM_FRAMES;


	int least = 1;
	int most = numFrames;
	int num = atoi( nums );
	if( num < least || num > most ) {
		CString msg;
		msg.Format( "Invalid frame: value must be between %d and %d", least, most );
		AfxMessageBox( msg );
	} else {
		m_frame_slider.SetPos( num );
		cav->OnCommitFrame( num );
	}*/

}

void CFDialog::OnPlayAnimation() 
{
	// TODO: Add your control notification handler code here
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnPlayAnimation( );
}

void CFDialog::OnStopAnimation() 
{
	// TODO: Add your control notification handler code here
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnStopAnimation( );

}

void CFDialog::OnInterpolate() 
{
	// TODO: Add your control notification handler code here
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnInterpolate( );

}

void CFDialog::OnArrowUp() 
{
	// TODO: Add your control notification handler code here
	mouseMoveXY( 0, changePoint );
}

void CFDialog::OnArrowLeft() 
{
	// TODO: Add your control notification handler code here
	mouseMoveXY( -changePoint, 0 );
}

void CFDialog::OnArrowDown() 
{
	// TODO: Add your control notification handler code here
	mouseMoveXY( 0, -changePoint );
}

void CFDialog::OnArrowRight() 
{
	// TODO: Add your control notification handler code here
	mouseMoveXY( changePoint, 0 );
}

void CFDialog::OnArrowForward() 
{
	// TODO: Add your control notification handler code here
	mouseMoveZ( -changePoint );

}

void CFDialog::OnArrowBackward() 
{
	// TODO: Add your control notification handler code here
	mouseMoveZ( changePoint );
}

void CFDialog::OnFrontAndCenter() 
{
	// TODO: Add your control notification handler code here
	frontAndCenter();
}

void CFDialog::OnFirstFrame() 
{
	// TODO: Add your control notification handler code here
	CString nums;
	nums.Format( "%d", 1 );
	m_frame_edit.SetWindowText( nums );
	m_frame_slider.SetPos( 1 );
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnGoToFrame( 1 );

}

void CFDialog::OnArrowLeftRotate() 
{
	// TODO: Add your control notification handler code here
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnMouseWheel( 0, -changeRotate, currPoint );
}

void CFDialog::OnArrowRightRotate() 
{
	// TODO: Add your control notification handler code here
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	cav->OnMouseWheel( 0, changeRotate, currPoint );
}

void CFDialog::OnFramesAnimationproperties() 
{
	// TODO: Add your command handler code here
	
	CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
	CFramesSetupDialog fs;

	int nf = cav->NUM_FRAMES;
	int fr = cav->FRAMERATE;

	fs.m_num_frames_edit_value.Format( "%d", nf );
	fs.m_framerate_edit_value.Format( "%d", fr );

	BOOL done = false;

	while( !done ) {

		if( fs.DoModal() == IDOK ) {
			nf = atoi( fs.m_num_frames_edit_value );
			fr = atoi( fs.m_framerate_edit_value );
			if( nf <= 0 ) {
				CString msg;
				msg.Format( "Number of frames must be positive" );
				AfxMessageBox( msg );
			} else if( fr <= 0 ) {
				CString msg;
				msg.Format( "Framerate must be positive" );
				AfxMessageBox( msg );
			} else {
				changeNumFrames( cav->NUM_FRAMES, nf - cav->NUM_FRAMES );
				if( nf < m_frame_slider.GetPos() ) {
					cav->OnGoToFrame( nf );
					CString txt;
					txt.Format( "%d", nf );
					m_frame_edit.SetWindowText( txt );
				}
				cav->NUM_FRAMES = nf;
				cav->FRAMERATE = fr;
				m_frame_spin.SetRange( 1, nf );
				m_frame_slider.SetRange( 1, nf );
				m_frame_slider.ClearSel( TRUE );
				done = true;
			}
		} else {
			done = true;
		}

	}

}
