// HelpDialog.cpp : implementation file
//

#include "stdafx.h"
#include "Animate.h"
#include "HelpDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelpDialog dialog


CHelpDialog::CHelpDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CHelpDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHelpDialog)
	m_help_edit_value = _T("");
	//}}AFX_DATA_INIT


	m_help_edit_value = "OC Animation -- Help\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Welcome to the OC Animation tool.  OC allows you to specify animations simply by using a mouse, and then apply the animations to Renderman Interface Bytestream (RIB) files, to easily create animations of beautifully rendered objects.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Using OC\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Overview:\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "When OC starts, you will see a red box in the middle of the screen.  This is the front side of the AniCube, a three-dimensional cube you can use to specify an animation in 3D.  This cube stands in for whatever object you will later apply this animation to.  Whatever you see the cube do is what the object in your RIB file will do.  It's that easy!\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Moving the AniCube:\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "XY translation:\tTo move the AniCube side to side or up and down, hold down the left mouse button in the window and move your mouse.  Release the left mouse button to stop.  You can also use the black, triangular arrows on the tool bar.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Z translation:\tTo move the AniCube backwards and forwards, hold down both the left and right mouse buttons in the window and move your mouse.  Release the buttons to stop.  You can also use the three-dimensional arrows on the tool bar.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "General rotation:\tTo rotate the AniCube about any axis, hold down the right mouse button in the window and move your mouse.  The AniCube will rotate about an axis perpendicular to your mouse stroke.  Release the button to stop.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Rotation about the Z axis:\tTo rotate the AniCube about an axis perpendicular to the screen, click the black rotation buttons on the tool bar.  If your mouse has a scrolling wheel, you can use this as well.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Front and Center:\tClick on the \"Front and Center\" button on the tool bar to bring the AniCube back to its starting position.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Animation:\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Frames:\tAn animation is made up of several frames, each of which specifies the AniCube at a certain position in space.  Using OC Animation, it is easy to create a few frames and then interpolate between them to generate a smooth animation.  There are several ways to move between frames in OC Animation:  you can use the slider bar in the tool bar to quickly move through the frames; you can enter a frame number into the \"Frame\" box in the tool bar and click the \"Go To Frame\" button on the tool bar; you can use to the \"Frames\"->\"Go To Frame\" menu item, which will ask you what frame you to what frame you want to go; or you can click the \"First Frame\" button on the tool bar or use the \"Frames\"->\"First Frame\" menu item to jump directly to the first frame of the animation.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Commiting a frame:\tOnce you move the AniCube into the desired position, you can commit that position to a certain frame in the animation by clicking the \"Commit Frame\" button on the tool bar, or choosing the \"Frames\"->\"Commit Frame\" menu item.  OC will ask you to which frame number you wish to commit the current position, and then save the position to that frame, overwriting whatever information was previously in that frame.  NOTE:  If you move the AniCube around, you must commit the current state to a frame before you go to another frame, otherwise you will lose that state.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Interpolating:\tYou can easily generate a smooth interpolation between two frames by using the \"Interpolate\" button on the tool bar, or by choosing the \"Frames\"->\"Interpolate\" menu item.  After you choose between which two frames to interpolate, OC will generate all frames in between the two to create a smooth animation.  NOTE:  This will overwrite any frames you had committed in between the two specified frames.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Playing the animation:\tYou can play your animation by clicking the \"Play Animation\" button on the tool bar or by choosing the \"Frames\"->\"Play Animation\" menu item. This will show your frames in succession, starting from the current frame until the last one.  You can press the \"Stop Animation\" button on the tool bar or choose the \"Frames\"->\"Stop Animation\" menu item to stop the animation at any time.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Animation properties:\tUsing the \"Frames\"->\"Animation Properties\" menu item, you can change the number of frames contained in the current animation, and change the rate at which the frames are played back during animation, specified in number of frames per second (FPS).  NOTE: If you decrease the number of frames in the animation, OC will truncate your animation to that size, thereby getting rid of any frames that may have existed past that point.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "New animations:\tYou can create a new animation by selecting the \"File\"->\"New\" menu item.  This will create a default animation of 30 frames, with a framerate of 20 FPS, and erase the current animation.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Saving/Loading animations:\tYou can save the animations you created in OC to files, or load previously saved animations, by using the \"File\"->\"Open\", \"File\"->\"Save\", or \"File\"->\"Save As\" menu items, just as any other Windows application.  The suggested file extension for OC Animations is \".oca\", but this is not strictly enforced.  NOTE: Loading an animation will cause OC to erase the current animation, so make sure you've saved.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Applying animations:\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Loading a RIB file:\tBy using the \"Publish\"->\"Load RIB file\" menu item, you can load a RIB file into memory.  OC will find the first \"Attibute\" defined in the RIB file, and will later apply the animation to this \"Attribute\".  You must be careful about how your RIB file is structured.  In particular, you should make sure it has no frames in it, and that there are no \"Translate\" commands within the first \"Attribute\" block, otherwise applying the animation could lead to unpredictable results, as OC will rotate the object around a point other than its (0,0,0) origin.  The tool bar tells you what RIB file is currently loaded into memory.\r\n";
	m_help_edit_value += "\r\n";
	m_help_edit_value += "Applying animations:\tYou can apply the current animation to the currenty loaded RIB file (as shown in the tool bar) by choosing the \"Publish\"->\"Apply Animation\" menu item.  This creates a RIB file with as many frames as your current animation has, with directions to render each frame in a separate file.  The name of these files (once you've rendered the file with Renderman) will be \"<title of new RIB file>_<frame number>.rib\".  You can then put these files together using a graphics program to create a cohesive animation.\r\n";
	m_help_edit_value += "\r\n";

}


void CHelpDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelpDialog)
	DDX_Control(pDX, IDC_HELP_EDIT, m_help_edit);
	DDX_Text(pDX, IDC_HELP_EDIT, m_help_edit_value);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHelpDialog, CDialog)
	//{{AFX_MSG_MAP(CHelpDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelpDialog message handlers
