// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Animate.h"

#include "MainFrm.h"

#include "FDialog.h"
#include "HelpDialog.h"
#include "AnimateView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_GO_TO_FRAME, OnGoToFrame)
	ON_BN_CLICKED(IDC_COMMIT_FRAME, OnCommitFrame)
	ON_BN_CLICKED(IDC_PLAY_ANIMATION, OnPlayAnimation)
	ON_BN_CLICKED(IDC_STOP_ANIMATION, OnStopAnimation)
	ON_BN_CLICKED(IDC_INTERPOLATE, OnInterpolate)
	ON_BN_CLICKED(IDC_ARROW_UP, OnArrowUp)
	ON_BN_CLICKED(IDC_ARROW_LEFT, OnArrowLeft)
	ON_BN_CLICKED(IDC_ARROW_DOWN, OnArrowDown)
	ON_BN_CLICKED(IDC_ARROW_RIGHT, OnArrowRight)
	ON_BN_CLICKED(IDC_ARROW_FORWARD, OnArrowForward)
	ON_BN_CLICKED(IDC_ARROW_BACKWARD, OnArrowBackward)
	ON_BN_CLICKED(IDC_ARROW_LEFT_ROTATE, OnArrowLeftRotate)
	ON_BN_CLICKED(IDC_ARROW_RIGHT_ROTATE, OnArrowRightRotate)
	ON_BN_CLICKED(IDC_FRONT_AND_CENTER, OnFrontAndCenter)
	ON_BN_CLICKED(IDC_FIRST_FRAME, OnFirstFrame)
	ON_COMMAND(ID_FRAMES_ANIMATIONPROPERTIES, OnFramesAnimationproperties)
	ON_COMMAND(ID_APPLY_LOADRIBFILE, OnApplyLoadribfile)
	ON_COMMAND(ID_APPLY_APPLYANIMATION, OnApplyApplyanimation)
	ON_COMMAND(ID_HELP_HELP, OnHelpHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	//m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	//EnableDocking(CBRS_ALIGN_ANY);
	//DockControlBar(&m_wndToolBar);

	m_frame_dialog.Create( this, IDD_FDIALOG, CBRS_TOP, IDD_FDIALOG );
	m_frame_dialog.SetWindowText( "Frames Control" );
	//m_frame_dialog.EnableDocking( CBRS_ALIGN_ANY );
	//DockControlBar( &m_frame_dialog );

	CString num;
	num.Format( "%d", 1 );
	m_frame_dialog.m_frame_edit_value = num;

	m_frame_dialog.m_rib_file_edit_value = "None";

	firstPart.Empty();
	secondPart.Empty();
	endPart.Empty();
	filename.Empty();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnGoToFrame() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnCommitFrame() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnPlayAnimation() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnStopAnimation() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnInterpolate() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowUp() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowLeft() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowDown() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowRight() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowForward() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowBackward() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowRightRotate() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnArrowLeftRotate() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnFrontAndCenter() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnFirstFrame() 
{
	// TODO: Add your control notification handler code here

}

void CMainFrame::OnGoToFrame( int frame ) 
{
	// TODO: Add your control notification handler code here
	CString num;
	num.Format( "%d", frame );
	m_frame_dialog.m_frame_edit.SetWindowText( num );
	m_frame_dialog.m_frame_slider.SetPos( frame );

}


void CMainFrame::OnFramesAnimationproperties() 
{
	// TODO: Add your command handler code here
	m_frame_dialog.OnFramesAnimationproperties();

}

void CMainFrame::OnApplyLoadribfile() 
{

	static char BASED_CODE szFilter[] = "RIB Files (*.rib)|*.rib|All Files (*.*)|*.*||";

	CFileDialog * fd = new CFileDialog( TRUE, ".rib", NULL, OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY, szFilter  );

	if( fd->DoModal() == IDOK ) {
		CFile * file = new CFile( fd->GetPathName(), CFile::modeRead );
		CArchive * currentRibAr = new CArchive( file, CArchive::load );
		filename = fd->GetFileTitle();
		firstPart.Empty();
		secondPart.Empty();
		endPart.Empty();
		CString tmp;
		while( currentRibAr->ReadString( tmp ) ) {
			if( tmp.Find( "WorldBegin" ) == -1 ) {
				if( (tmp.Find( "Display" ) == -1) ) {
					firstPart = firstPart + tmp;
					firstPart = firstPart + "\n";
				}
			} else {
				break;
			}
		}
		while( currentRibAr->ReadString( tmp ) ) {
			if( tmp.Find( "AttributeBegin" ) == -1 ) {
				secondPart = secondPart + tmp;
				secondPart = secondPart + "\n";
			} else {
				break;
			}
		}
		while( currentRibAr->ReadString( tmp ) ) {
			if( tmp.Find( "WorldEnd" ) == -1 ) {
				endPart = endPart + tmp;
				endPart = endPart + "\n";
			} else {
				break;
			}
		}
		
		m_frame_dialog.m_rib_file_edit.SetWindowText( file->GetFileName() );

		file->Close();
		currentRibAr->Close();
		delete file;
		delete currentRibAr;
		
	}

}

void CMainFrame::OnApplyApplyanimation() 
{

	if( filename.IsEmpty() ) {

		AfxMessageBox( "You must load a RIB file before applying this animation." );
		return;

	}

	static char BASED_CODE szFilter[] = "RIB Files (*.rib)|*.rib|All Files (*.*)|*.*||";

	CFileDialog * fd = new CFileDialog( FALSE, ".rib", filename + "_movie.rib", OFN_OVERWRITEPROMPT, szFilter  );

	if( fd->DoModal() == IDOK ) {

		CFile * file = new CFile( fd->GetPathName(), CFile::modeCreate | CFile::modeWrite );
		CArchive * currentRibAr = new CArchive( file, CArchive::store );

		CString temp;
		CString filetitle = file->GetFileTitle();

		CAnimateView * cav = (CAnimateView *) ((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();
		int nf = cav->NUM_FRAMES;

		currentRibAr->WriteString( firstPart );
		for( int i = 1; i <= nf; i++ ) {
			temp.Format( "FrameBegin %d\n", i );
			currentRibAr->WriteString( temp );
			temp.Format( "_%d.tif", i );
			currentRibAr->WriteString( "Display " );
			currentRibAr->WriteString( "\"" + filetitle + temp + "\"" );
			currentRibAr->WriteString( " \"file\" \"rgb\"\n" );
			currentRibAr->WriteString( "WorldBegin\n" );
			currentRibAr->WriteString( secondPart );
			currentRibAr->WriteString( "AttributeBegin\n" );
			currentRibAr->WriteString( cav->GetTranslationFor( i ) );
			currentRibAr->WriteString( cav->GetRotationFor( i ) );
			currentRibAr->WriteString( endPart );
			currentRibAr->WriteString( "WorldEnd\n" );
			currentRibAr->WriteString( "FrameEnd\n" );
		}

		currentRibAr->Flush();
		file->Close();
		currentRibAr->Close();
		delete file;
		delete currentRibAr;
	}

	
}

void CMainFrame::OnHelpHelp() 
{
	// TODO: Add your command handler code here

	CHelpDialog hd;


	hd.DoModal();

}
